%%%This script is used to extract variables from the WRF output files and save them to a netcdf file

function [] = wrfextract_nc(year)

path='/archive/u1/uaf/lcai4/CESM_WRF_10km_raw/';

    DOY=1;
    for month=1:12
%%%%%determine the days of a certain month, choose not to consider leap year. 
        if (month==1) || (month==3) || (month==5) || (month==7) || (month==8) || (month==10) || (month==12)
            i=31;
        elseif (month==4) || (month==6) || (month==9) || (month==11)
                i=30;

                else
                    i=28;
        end
      
    disp(year); 
    disp(month);
    disp(i);
          
       for day=1:i
    disp(day);    %%% 3 hourly interval%%%
        s1=strcat(path,'/run_',num2str(year),num2str(month,'%02i'),'/wrfout_d01_',num2str(year),'-',num2str(month,'%02i'),'-',num2str(day,'%02i'),'_00:00:00');
        s2=strcat(path,'/run_',num2str(year),num2str(month,'%02i'),'/wrfout_d01_',num2str(year),'-',num2str(month,'%02i'),'-',num2str(day,'%02i'),'_03:00:00');
        s3=strcat(path,'/run_',num2str(year),num2str(month,'%02i'),'/wrfout_d01_',num2str(year),'-',num2str(month,'%02i'),'-',num2str(day,'%02i'),'_06:00:00');
        s4=strcat(path,'/run_',num2str(year),num2str(month,'%02i'),'/wrfout_d01_',num2str(year),'-',num2str(month,'%02i'),'-',num2str(day,'%02i'),'_09:00:00');
        s5=strcat(path,'/run_',num2str(year),num2str(month,'%02i'),'/wrfout_d01_',num2str(year),'-',num2str(month,'%02i'),'-',num2str(day,'%02i'),'_12:00:00');
        s6=strcat(path,'/run_',num2str(year),num2str(month,'%02i'),'/wrfout_d01_',num2str(year),'-',num2str(month,'%02i'),'-',num2str(day,'%02i'),'_15:00:00');
        s7=strcat(path,'/run_',num2str(year),num2str(month,'%02i'),'/wrfout_d01_',num2str(year),'-',num2str(month,'%02i'),'-',num2str(day,'%02i'),'_18:00:00');
        s8=strcat(path,'/run_',num2str(year),num2str(month,'%02i'),'/wrfout_d01_',num2str(year),'-',num2str(month,'%02i'),'-',num2str(day,'%02i'),'_21:00:00');
          
              ncid00=netcdf.open(s1,'NC_NOWRITE');
              ncid03=netcdf.open(s2,'NC_NOWRITE');
              ncid06=netcdf.open(s3,'NC_NOWRITE');
              ncid09=netcdf.open(s4,'NC_NOWRITE');
              ncid12=netcdf.open(s5,'NC_NOWRITE');
              ncid15=netcdf.open(s6,'NC_NOWRITE');
              ncid18=netcdf.open(s7,'NC_NOWRITE');
              ncid21=netcdf.open(s8,'NC_NOWRITE'); 
              
              XLONG(:,:)=netcdf.getVar(ncid00,2);
              XLAT(:,:)=netcdf.getVar(ncid00,1);
              
              for hr=0:7
                  h_temp=num2str(3*hr,'%02i');
                  hour=hr+1;
                  ncid=strcat('ncid',h_temp);
                 eval(['Q2(:,:,DOY,hour)=netcdf.getVar(',ncid,',36);']);
                 eval(['T2(:,:,DOY,hour)=netcdf.getVar(',ncid,',37);']);
                 eval(['raintemp(:,:,DOY,hour)=netcdf.getVar(',ncid,',103)+netcdf.getVar(',ncid,',105);']);
                 eval(['snow(:,:,DOY,hour)=netcdf.getVar(',ncid,',73);']);
                 eval(['snowh(:,:,DOY,hour)=netcdf.getVar(',ncid,',74);']);
                 eval(['snowrho(:,:,DOY,hour)=netcdf.getVar(',ncid,',75);']);
                 eval(['U10(:,:,DOY,hour)=netcdf.getVar(',ncid,',40);']);
                 eval(['V10(:,:,DOY,hour)=netcdf.getVar(',ncid,',41);']);
                 eval(['SEAICE(:,:,DOY,hour)=netcdf.getVar(',ncid,',63);']);
                 eval(['PSFC(:,:,DOY,hour)=netcdf.getVar(',ncid,',39);']);
                 eval(['SWDOWN(:,:,DOY,hour)=netcdf.getVar(',ncid,',111);']);
                  eval(['GLW(:,:,DOY,hour)=netcdf.getVar(',ncid,',112);']);
                 %%%%%call the function to calculate the dew point temperature from temperature, moisture, and pressure at the surface
                 TD2(:,:,DOY,hour)=Q2TD(Q2(:,:,DOY,hour),PSFC(:,:,DOY,hour),T2(:,:,DOY,hour)); 
                eval(['netcdf.close(',ncid,');']);
              end
                  
  
   
    DOY=DOY+1;
             

       end   
    end
    DOY=DOY-1;
    %%%% WRF precipitation output records accumulated precipitation, here to calculate the precpitation for each time step by substracting
    %%%% precipitation amount (t+1) and (t). 	
     for day=1:DOY
         for hr=1:7
               rain(:,:,day,hr)=raintemp(:,:,day,hr+1)-raintemp(:,:,day,hr);
         end
         if day<DOY
         rain(:,:,day,8)=raintemp(:,:,day+1,1)-raintemp(:,:,day,8);
         else
             rain(:,:,day,8)=0;
         end
     end

     rain(find(rain<0.1))=0;
     rain(find(rain>300))=0;
           
    clear ncid* s1 s2 s3 s4 s5 s6 s7 s8 month day hr

    
%%%%creating netcdf files%%%%    
nt=DOY;
nx=179;
ny=149;
nh=8;
time=1:nt;
hour=0:3:21;
disp('Create file Netcdf...')
filenc=strcat('CESM_WRF_',int2str(year),'_type2.nc'); 
%filenc=strcat('NCEP_WRF_',int2str(year),'.nc'); 
%filenc=strcat('PWRFout_',int2str(year),'_type4.nc'); 
ncid = netcdf.create(filenc,'64BIT_OFFSET');
% Create dimensiones
dimid_lon = netcdf.defDim(ncid,'longitude',nx);
dimid_lat = netcdf.defDim(ncid,'latitude',ny); 
dimid_time = netcdf.defDim(ncid,'time',nt); 
dimid_hour = netcdf.defDim(ncid,'hour',nh);
% Create variables
%
varid_rain = netcdf.defVar(ncid,'rain','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_rain,'long_name','Total_precipitation')
netcdf.putAtt(ncid,varid_rain,'units','mm')
netcdf.putAtt(ncid,varid_rain,'missing_value',-9999)
%
varid_snow = netcdf.defVar(ncid,'snow','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_snow,'long_name','snow_water_equivalent')
netcdf.putAtt(ncid,varid_snow,'units','kg m-2')
netcdf.putAtt(ncid,varid_snow,'missing_value',-9999)
% %
varid_snowh = netcdf.defVar(ncid,'snowh','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_snowh,'long_name','snow_depth')
netcdf.putAtt(ncid,varid_snowh,'units','m')
netcdf.putAtt(ncid,varid_snowh,'missing_value',-9999)
% %
varid_snowrho = netcdf.defVar(ncid,'snowrho','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_snowrho,'long_name','snow_density')
netcdf.putAtt(ncid,varid_snowrho,'units','kg m-3')
netcdf.putAtt(ncid,varid_snowrho,'missing_value',-9999)
% %
varid_U10 = netcdf.defVar(ncid,'U10','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_U10,'long_name','X_component_wind_speed')
netcdf.putAtt(ncid,varid_U10,'units','m/s')
netcdf.putAtt(ncid,varid_U10,'missing_value',-9999)
% %
varid_V10 = netcdf.defVar(ncid,'V10','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_V10,'long_name','Y_component_wind_speed')
netcdf.putAtt(ncid,varid_V10,'units','m/s')
netcdf.putAtt(ncid,varid_V10,'missing_value',-9999)
% %
% %
varid_T2 = netcdf.defVar(ncid,'T2','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_T2,'long_name','2m_temperature')
netcdf.putAtt(ncid,varid_T2,'units','K')
netcdf.putAtt(ncid,varid_T2,'missing_value',-9999)
% %
varid_TD2 = netcdf.defVar(ncid,'TD2','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_TD2,'long_name','2m_dewpoint_temperature')
netcdf.putAtt(ncid,varid_TD2,'units','K')
netcdf.putAtt(ncid,varid_TD2,'missing_value',-9999)

varid_Q2 = netcdf.defVar(ncid,'Q2','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_Q2,'long_name','2m_mixing_ratio')
netcdf.putAtt(ncid,varid_Q2,'units','g/g')
netcdf.putAtt(ncid,varid_Q2,'missing_value',-9999)
%
varid_SEAICE = netcdf.defVar(ncid,'SEAICE','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_SEAICE,'long_name','seaice_cover')
netcdf.putAtt(ncid,varid_SEAICE,'units','logical')
netcdf.putAtt(ncid,varid_SEAICE,'missing_value',-9999)
%
varid_PSFC = netcdf.defVar(ncid,'PSFC','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_PSFC,'long_name','surface_pressure')
netcdf.putAtt(ncid,varid_PSFC,'units','Pa')
netcdf.putAtt(ncid,varid_PSFC,'missing_value',-9999)
% %
varid_SWDOWN = netcdf.defVar(ncid,'SWDOWN','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_SWDOWN,'long_name','downward_short_wave_radiation')
netcdf.putAtt(ncid,varid_SWDOWN,'units','W m-2')
netcdf.putAtt(ncid,varid_SWDOWN,'missing_value',-9999)
% %
varid_GLW = netcdf.defVar(ncid,'GLW','double',[dimid_lon,dimid_lat,dimid_time,dimid_hour]);
netcdf.putAtt(ncid,varid_GLW,'long_name','downward_long_wave_radiation')
netcdf.putAtt(ncid,varid_GLW,'units','W m-2')
netcdf.putAtt(ncid,varid_GLW,'missing_value',-9999)
%
varid_lon = netcdf.defVar(ncid,'longitude','double',[dimid_lon,dimid_lat]);
netcdf.putAtt(ncid,varid_lon,'long_name','Longitude')
netcdf.putAtt(ncid,varid_lon,'units','degrees_east')
% 
varid_lat = netcdf.defVar(ncid,'latitude','double',[dimid_lon,dimid_lat]);
netcdf.putAtt(ncid,varid_lat,'long_name','Latitude')
netcdf.putAtt(ncid,varid_lat,'units','degrees_north')
%
varid_time = netcdf.defVar(ncid,'time','double',dimid_time);
netcdf.putAtt(ncid,varid_time,'long_name','Time')
netcdf.putAtt(ncid,varid_time,'units','day')
% 
varid_hour = netcdf.defVar(ncid,'hour','double',dimid_hour);
netcdf.putAtt(ncid,varid_hour,'long_name','hour')
netcdf.putAtt(ncid,varid_hour,'units','hour')

netcdf.endDef(ncid)
% % % write variables in the created netcdf file

 netcdf.putVar(ncid,varid_time,time);
 netcdf.putVar(ncid,varid_hour,hour);
 netcdf.putVar(ncid,varid_rain,rain);
 netcdf.putVar(ncid,varid_snow,snow);
 netcdf.putVar(ncid,varid_snowh,snowh);
 netcdf.putVar(ncid,varid_snowrho,snowrho);
 netcdf.putVar(ncid,varid_T2,T2);
 netcdf.putVar(ncid,varid_TD2,TD2);
 netcdf.putVar(ncid,varid_Q2,Q2);
 netcdf.putVar(ncid,varid_U10,U10);
 netcdf.putVar(ncid,varid_V10,V10);
 netcdf.putVar(ncid,varid_SEAICE,SEAICE);
netcdf.putVar(ncid,varid_PSFC,PSFC);
netcdf.putVar(ncid,varid_SWDOWN,SWDOWN);
netcdf.putVar(ncid,varid_GLW,GLW);
netcdf.putVar(ncid,varid_lon,XLONG);
netcdf.putVar(ncid,varid_lat,XLAT);

netcdf.close(ncid) 
clear all
